module Utilities where

{-
 	- Tar en tuple av funktioner och en tuple av variabler
	- Applicerar den frsta funktionen p den frsta variabeln och den andra funktionen p den andra variabeln.
-}
map2 :: (a -> b, c -> d) -> (a, c) -> (b, d)
map2 (f1, f2) (x1, x2) = (f1 x1, f2 x2)

{- 
 	"Gr att en funktion kan ta maybe som paramter nr den egentligen inte vill det"
 	- Om den andra parametern r Nothing s returnerar vi Nothing
 	- annars returnerar vi resultatet av den frsta funktionen nr den andra parametern skickas in i den
-}
mmap :: (a -> b) -> Maybe a -> Maybe b
mmap f  Nothing  = Nothing
mmap f (Just x)  = Just (f x)

{- Om det frsa r nothing s returneras det andra. Annars returneras det frsta. -}
orElse :: Maybe a -> Maybe a -> Maybe a
orElse Nothing  x  = x
orElse (Just a) _  = Just a

{- 
 	- Tar en funktion som returnerar "Maybe", samt ett vrde.
 	- Ifall vrdet insatt i funktionen blir Nothing returneras det ursprungliga vrdet,
 	- Annars resultatet av funktionen p vrdet.
-}
try :: (a -> Maybe a) -> a -> a
try f x = maybe x id (f x)

{- Applicerar funktionen f p argumentet x rekursivt tills x r "stabilt" -}

fix :: Eq a => (a -> a) -> a -> a
fix f x
   |  f x == x  = x
   |  otherwise = fix f (f x)

{- Slumptal, blabla -}
pick :: RealFrac r => r -> [a] -> a
pick u xs = xs !! (floor.(u*).fromIntegral.length) xs

