<html>
<head>
        <title>Funktionell musik</title>
		<style type="text/css" media="screen">
			h1.title, h5.title{text-align:center;}
			body{font-size:14px;font-family:helvetica,arial;}
			pre, code{font-family:'andale mono',monospace;}
			pre{background:#eef;}
		</style>
</head>
<body>
<h1 class="title">Funktionell Musik</h1>
<h5 class="title">Fredrik Andersson dt07fa5, Hannes Nevalainen dt07hn2</h5>
<h2>Lsa noter</h2>
<p>Musik r ofta representerad som noter. Melodin r representerad som "prickarna" p linjerna. Tonhjden bestms utifrn notens relation till de horisontella linjerna. Ovanfr notlinjerna finns det bokstver som beskriver vilket ackord (delmngd noter) som kan anvndas fr att ackompanjera melodin.</p>
<p>Tonhjd mts p en logaritmisk skala. En frdubbling av frekvensen delas in i 12 halvtoner och kallas <em>oktav</em>. Varje ton har ett eget namn. Heltonerna (de vita p pianot) har unika namn, medan de andra har olika namn beroende p vilken tonart man anvnder sig av.</p>
<img src="http://fileadmin.cs.lth.se/cs/Education/EDAN40/assignment2/keys.gif" />
<p>Nedan finns noterna till <em>Blinka lilla stjrna</em>.</p>
<p><img src="http://fileadmin.cs.lth.se/cs/Education/EDAN40/assignment2/twinkle.gif" /></p>
Lngden p en not mts som delar utav en takt. Till exempel s betyder den ihliga noten med en pinne att lngden r en halv takt. Fr att kunna bestmma den faktiska tid som en not ska spelas s mste man bestmma ett <em>tempo</em> som oftast mts i bpm (beats per minute / slag per minut).
<p><img src="http://fileadmin.cs.lth.se/cs/Education/EDAN40/assignment2/notes.gif" /></p>
<pre>
	
> module Accompaniments where
> import Haskore hiding (Major, Minor, Key)

</pre>
En ackordfljd (chord progression) r det som visar hur man ska ackompanjera melodin.
<h2>Definitioner</h2>
<pre>
	
> type Chord = (PitchClass, Dur)
> type ChordProgression = [Chord]
> data HarmonicQuality = Minor | Major
>	deriving (Eq, Show)
> type Key = (PitchClass, HarmonicQuality)
> data Beat = Int | Silence
> 	deriving (Eq, Show)

</pre>
<h2>Lite musikteori</h2>
<p>De toner som ingr i en viss tonart kallas fr en skala. Fr att bestmma vilka toner som ingr i en viss skala s mste man veta en grundton och vilket skalmnster som ska anvndas.</p>
<p>Tv vanliga mnster r <em>dur</em> (major) och <em>moll</em> (minor).</p> 
<pre>
	
> type ScalePattern = [Int]
> minor :: ScalePattern
> minor = [0, 2, 3, 5, 7, 8, 10]
> major :: ScalePattern
> major = [0, 2, 4, 5, 7, 9, 11]

> type PitchList = [PitchClass]
> pitchList = [C, Cs, D, Ds, E, F, Fs, G, Gs, A, As, B]

</pre>
<code>scale</code> tar en en tonart och ger tillbaka ondliga lista med toner som ingr i tonarten och som brjar med grundtonen.
<pre>
	
> scale :: Key -> [PitchClass]
> scale (pitchClass, harmonicQuality) =
>	let reorderedScale = ((dropWhile (< pitchClass) pitchList) ++ (takeWhile (< pitchClass) pitchList))
> 	in cycle $ map (reorderedScale !!) scalePattern
>       where scalePattern 
>       	| (harmonicQuality == Major) = major
>       	| (harmonicQuality == Minor) = minor

</pre>
<h2>Automagiskt ackompanjemang</h2>
Ackompanjemanget r uppdelat i tv delar, en basslinga och enkla ackord lagda p frsta slaget i varje takt, eller p varje halvtakt.
Ackompanjemanget genereras utifrn ackordfljden.
<h3>Basslinga</h3>
<p>Det finns olika stt att generera en basslinga p. De stilar som vi har r <code>basic</code>, <code>calypso</code> och <code>boogie</code>.</p> En nolla p frsta platsen i tuplerna i <code>Basstyle</code> signalerar en paus.
<pre>
		
> type BassStyle = [(Int, Dur)]
> basic,calypso,boogie :: BassStyle
> basic = [(1, hn),(5, hn)]
> calypso = [(0, qn),(1, en),(3, en),(0, qn),(1, en),(3, en)]
> boogie = [(1, en),(5, en),(6, en),(5, en),(1, en),(5, en),(6, en),(5, en)]

</pre>
<code>applyBassStyleToChord</code> anvnder sig av stil, tonart och ett ackord fr att generera basgngen fr en takt.
<pre>

> applyBassStyleToChord :: BassStyle -> Key -> Chord -> Music
> applyBassStyleToChord style key (pitchClass, dur) = 
>	let chordScale = octaveIntervall (C,3) $ dropWhile (< pitchClass) (scale key)
>	in foldl1 (:+:) $ map (bassNote chordScale) fixedStyle
>		where fixedStyle 
>			| (dur==hn) = take ((quot.length) style 2) style
>			| (dur==wn) = style

</pre>
<code>bassNote</code> plockar ut rtt ton frn tonartslistan och skapar en <code>Note</code> utav det.
<pre>
	
> bassNote :: [Pitch] -> (Int, Dur) -> Music
> bassNote scale (pos,dur)
>	| (pos==0) = Rest dur
>	| otherwise = Note (scale !! (pos-1)) dur [Volume 80]

</pre>
Funktionerna nedan anvnds fr att skapa en lista med toner som finns i ett visst intervall i den angivna tonarten.
<pre>

> octaveIntervall :: Pitch -> [PitchClass] -> [Pitch]
> octaveIntervall start list = take 12 $ tail $ scanl (addOctave) start list


> addOctave :: Pitch -> PitchClass -> Pitch
> addOctave (previousPitchClass, octave) currentPitchClass
>	| (previousPitchClass == B) = (currentPitchClass, octave+1)
>	| otherwise = (currentPitchClass, octave)


</pre>
<code>autoBass</code> genererar en basslinga baserat p stil, tonart och ackordfljd.
<pre>

> autoBass :: BassStyle -> Key -> ChordProgression -> Music
> autoBass style key list = foldl1 (:+:) (map (applyBassStyleToChord style key) list)

</pre>


<h2>Autoackord</h2>
En triad bestr av tre stycken toner (Pitches). Dessa passar ihop med melodin, men kan vljas p mnga olika stt. Beroende p hur de vljs kan man f det att lta olika. Vissa av kombinationerna lter bttre n andra och vi har anvnt oss av ngra tumregler fr att det ska lta bra.
<pre>

> type Triad = (Pitch, Pitch, Pitch)

</pre>

I vrt fall vljs triaden som en funktion av den fregende.
<pre>

> autoChord :: Key -> ChordProgression -> Music
> autoChord key song = makeMusic song $ tail $ scanl (chooseTriad key) ((C,0),(C,0),(C,0)) song

</pre>

Tonerna i varje triad bestms enligt ett mnster som r angivet enligt tonarten (Key). Detta ger sedan olika Triads som ligger i olika oktaver. En Triad kan ven vara utspridd ver ett strre omrde, men vi vljer att bara ta med de som r i sluten intonation (closed voicing).

<pre>

> allTriads :: Key -> Chord -> [Triad]
> allTriads key (pc, _) = 
>	let
>		myScale = dropWhile (< pc) (scale key)
>		pitches = octaveIntervall (C,1) myScale
>	in
>		triadList (pitches !! 0, pitches !! 2, pitches !! 4)

> triadList :: Triad -> [Triad]
> triadList f = f : map (nextTriad) (triadList f)

> nextTriad :: Triad -> Triad
> nextTriad ((pc1, o1), p2, p3) = (p2, p3, (pc1, o1+1))

</pre>

Som tumregeln anvnder vi hr att alla tonerna i vra Triads skall ligga i intervallet (E,4) till (G,5). Resterande kastas bort.

<pre>

> filterTriad :: Triad -> Bool
> filterTriad (t1, t2, t3) = foldl1 (&&) [ a >= absPitch (E,4) && a <= absPitch (G,5) | a<-map (absPitch) [t1,t2,t3]  ]

</pre>

Avstndet mellan tv Triads mts genom att man tittar p avstndet mellan alla tonerna och summerar ihop detta.
<pre>

> triadDistance :: Triad -> Triad -> Int
> triadDistance (a1, a2, a3) (b1, b2, b3) = 
>		((-).abs) (absPitch a1) (absPitch b1) + 
>		((-).abs) (absPitch a2) (absPitch b2) + 
>		((-).abs) (absPitch a3) (absPitch b3)

</pre>

Nr det finns flera Triads i intervallet (E,4) till (G,5) vljs den som har kortast avstnd till den fregende Triaden.

<pre>

> shortestDistance :: Triad -> Triad -> Triad -> Triad
> shortestDistance ref a b 
>			| triadDistance ref a < triadDistance ref b = a
>			| otherwise = b

> chooseTriad :: Key -> Triad -> Chord -> Triad
> chooseTriad key prev c = 
>		let
>			all = takeWhile filterTriad $ dropWhile (not.filterTriad) $ allTriads key c 
>		in foldl1 (shortestDistance prev) all

</pre>




Nedan fljer lite funktioner fr att omvandla triaderna till Musikobjekt, ackordets lngd bestmmer vilken lngd respektive not fr.

<pre>

> makeMusic :: [Chord] -> [Triad] -> Music
> makeMusic cs ts = foldl1 (:+:) $ zipWith triadToMusic cs ts

> triadToMusic :: Chord -> Triad -> Music
> triadToMusic (_, dur) (p1, p2, p3) = foldr1 (:=:) [ Note (x) dur [Volume 80] | x<-[p1, p2, p3] ]

</pre>

<h2>Sl ihop allting</h2>
<pre>

> autoComp :: BassStyle -> Key -> ChordProgression -> Music
> autoComp bass key chords =
> 			(Instr "piano" (Tempo 3 (Phrase [Dyn SF] (autoBass bass key chords)))) :=:
>			(Instr "piano" (Tempo 3 (Phrase [Dyn SF] (autoChord key chords))))

</pre>
</body>
</html>
