module SleepingBear where
import Accompaniments
import Haskore hiding (Major, Minor, Key)

-- note updaters for mappings
fd d n = n d v
vol n = n v
v = [Volume 80]
lmap f l = line (map f l)

-- Main Voice:
v1a = lmap (fd qn) [c 5, c 5, c 5, e 5, d 5, d 5, d 5, f 5, e 5, e 5, d 5, d 5]
--v1b = lmap (fd hn) [c 5]
v1b = vol $ c 5 hn
v1 = v1a :+: v1b :+: hnr

v2 = lmap (vol) [e 5 qn, e 5 qn, e 5 qn, e 5 qn, g 5 hn, f 5 hn, d 5 qn, d 5 qn, d 5 qn, d 5 qn, f 5 hn, e 5 hn]

mainVoice = v1 :+: v2 :+: v1

-- Putting it all together:
bearMelody = Instr "piano" (Tempo 3 (Phrase [Dyn SF] mainVoice))

bearChords =
	[
		(C,wn),(G,wn),(C,hn),(G,hn),(C,wn),
		(C,wn),(D,wn),(G,wn),(C,wn),
		(C,wn),(G,wn),(C,hn),(G,hn),(C,wn)
	]

bearBasic = bearMelody :=: autoComp basic (C, Major) bearChords
