module TwinkleTwinkle where
import Accompaniments
import Haskore hiding (Major, Minor, Key)

-- note updaters for mappings
fd d n = n d v
vol n = n v
v = [Volume 80]
lmap f l = line (map f l)

-- repeat something n times
times 1 m = m
times (n+1) m = m :+: (times n m)

-- Main Voice:
v1 = v1a :+: v1b
v1a = lmap (fd qn) [c 5, c 5, g 5, g 5, a 5, a 5]
v1b = lmap (fd hn) [g 5]

v2 = v2a :+: v2b :+: v2c
v2a = lmap (fd qn) [f 5, f 5]
v2b = lmap (fd qn) [e 5, e 5]
v2c = lmap (vol) [d 5 qn, d 5 qn, c 5 hn]

v3 = Trans 2 v2a :+: Trans 1 v2b :+: Trans 2 v2c

mainVoice = v1 :+: v2 :+: times 2 v3 :+: v1 :+: v2


-- Putting it all together:
twinkleMelody = Instr "piano" (Tempo 3 (Phrase [Dyn SF] mainVoice))

twinkleChords =
	[
		(C,wn),(F,hn),(C,hn),(G,hn),(C,hn),(G,hn),(C,hn),
		(C,hn),(G,hn),(C,hn),(G,hn),(C,hn),(G,hn),(C,hn),(G,hn),
		(C,wn),(F,hn),(C,hn),(G,hn),(C,hn),(G,hn),(C,hn)
	]

twinkleBasic   = twinkleMelody :=: autoComp basic (C, Major) twinkleChords
twinkleCalypso = twinkleMelody :=: autoComp calypso (C, Major) twinkleChords
twinkleBoogie  = twinkleMelody :=: autoComp boogie (C, Major) twinkleChords
