module Uppg2 where
import Data.List

scoreMatch = 0
scoreMismatch = -1
scoreSpace = -1
string1 = "writers"
string2 = "vintner"
-- similarityScore = -5

--scoreMatch = 2
--scoreMismatch = -1
--scoreSpace = -2
--string1 = "GAATTCAGTTA"
--string2 = "GGATCGA"
-- similarityScore = 3


-- A
similarityScore :: String -> String -> Int
similarityScore [] [] = 0
similarityScore (x:xs) [] = scoreSpace + similarityScore xs []
similarityScore [] (y:ys) = scoreSpace + similarityScore [] ys
similarityScore (x:xs) (y:ys) = 
	maximum [
		twoNonSpace + similarityScore xs ys,
		scoreSpace + similarityScore xs (y:ys),
		scoreSpace + similarityScore (x:xs) ys
	]
	where twoNonSpace
		| x==y = scoreMatch
		| otherwise = scoreMismatch
		
-- B
{- 
 - Tar tv element av samma typ, samt en lista av tupler av listor.
 - Samt stter in dessa tv elementen lngst fram i varje list.
 - 
 - T ex om man fr tv tecken och en lista med par av strngar s
 - kommer dessa tv tecknen att sttas in lngst fram i varje strng.
 - Dr det frsta tecknet stts in i det frsta paret och det andra tecknet i det andra paret.
 -}
attachHeads :: a -> a -> [([a],[a])] -> [([a],[a])]
attachHeads h1 h2 aList = [(h1:xs,h2:ys) | (xs,ys) <- aList] 


-- C
maximaBy :: Ord b => (a -> b) -> [a] -> [a]
maximaBy valueFcn xs = filter (\x -> valueFcn x == longest) xs
	where longest = maximum $ map valueFcn xs


-- D
type AlignmentType = (String,String)
optAlignments :: String -> String -> [AlignmentType]
optAlignments [] [] = [([],[])]
optAlignments (x:xs) [] = attachHeads x '-' $ optAlignments xs []
optAlignments [] (y:ys) = attachHeads '-' y $ optAlignments [] ys
optAlignments (x:xs) (y:ys) = maximaBy alignScore $ 
			(attachHeads x y $ optAlignments xs ys)
			++
			(attachHeads x '-' $ optAlignments xs (y:ys))
			++
			(attachHeads '-' y $ optAlignments (x:xs) (ys))

--alignScore :: AlignmentType -> Int
--alignScore (x,y) = similarityScore x y

-- E
alignScore :: AlignmentType -> Int
alignScore (x:xs, y:ys)
	| (x=='-' || y=='-') = scoreSpace + alignScore(xs,ys)
	| x==y = scoreMatch + alignScore (xs,ys)
	| otherwise = scoreMismatch + alignScore(xs,ys)
alignScore (x:xs, []) = scoreSpace + alignScore(xs, [])
alignScore ([], y:ys) = scoreSpace + alignScore([], ys)
alignScore ([], []) = 0




outputOptAlignments :: String -> String -> IO ()
outputOptAlignments x y = do 
	putStrLn ("There are " ++ show (length result) ++ " optimal alignments:")
	putStrLn $ concat $ map outputOptAlignment result
	where
		outputOptAlignment :: AlignmentType -> String
		outputOptAlignment (x,y) = "\n" ++ x ++ "\n" ++ y ++ "\n"
		result = optAlignments x y

